# 陈一潇
# 1400017639


def dsa1_reverse(s, n):
    """接受一个字符串和一个正整数 n 作为参数，
    返回把原字符串字符位置向右移动 n 个字符的字符串."""
    return s[-n:] + s[:-n]


def dsa1_factorialSum(n):
    """接受一个正整数 n 作为参数，返回 s=1!+2!+3!+……+n!的值"""
    from math import factorial
    return sum([factorial(i) for i in range(1, n+1)])


def dsa1_generateDict(keys, values):
    """接受两个长度相同的元组，用这两个元组中的所有数据组成一个字典并返回。"""
    return dict(zip(keys, values))


def dsa1_en2num(s):
    """接受一个英文字符串作为参数，返回该字符串的整数表示。"""
    dict_en2num = {"one": 1, "two": 2, "three": 3, "four": 4, "five": 5,
                    "six": 6, "seven": 7, "eight": 8, "nine": 9, "zero": 0}
    return int("".join(map(lambda x :str(dict_en2num[x]), s.split("-"))))


def dsa1_getUnion(s1,s2):
    """接受两个字符串作为参数，返回两个字符串字符集合的并集。"""
    return set(s1) | set(s2)


def dsa1_getDays(y, m):
    """接受两个参数 y 和 m，分别表示年和月，返回此年此月的天数。"""
    from calendar import monthrange
    return monthrange(y, m)[1]


def dsa1_isNarcNum(n):
    """接受一个参数 n(n>=100)，判断这个数是否为水仙花数"""
    return n == int(sum([int(i) ** len(str(n)) for i in str(n)]))


def dsa1_writeNarcNum(max):
    """接受一个参数 max(max>=1000)，
    调用第 7 题编写的函数，求100 到 max 之间的水仙花数，
    并且输出到一个名为 narcissistic.txt 的文件中，每个数作为一行输出。"""
    with open("narcissistic.txt", "w+") as file:
        for num in range(100, int(max) + 1):
            if dsa1_isNarcNum(num):
                file.write(str(num) + "\n")


def dsa1_readNarcNum():
    """读入第 8 题中输出的文件 narcissistic.txt，
    以列表的形式返回文件中的水仙花数，列表的每个元素类型为 int 型"""
    with open("narcissistic.txt", "r") as file:
        return [int(i) for i in file.readlines()]


def dsa1_printTri(n):
    """接受一个参数 n，在屏幕上打印出杨辉三角形的前 n 行"""
    # line = [1]
    # for i in range(n):
    #     new_line = [1] * (i + 1)
    #     for j in range(1, i):
    #         new_line[j] = line[j-1] + line[j]
    #     print(" ".join([str(k) for k in new_line]))
    #     line = new_line
    old_line = dsa1_printTri(n-1) if n > 1 else [1]
    line = [old_line[j-1]+old_line[j] if 0 < j < n - 1  else 1 for j in range(n)]
    print(" ".join([str(k)for k in line]))
    return line


# if __name__ == "__main__":
#     dsa1_printTri(10)